/**
 * ===========================================================================
 * Book.java: Book class stores book information, after parsing the xml ...
 * ===========================================================================
 */

package book01;

import java.util.Date;
import java.util.List;
import java.util.ArrayList;

public class Book {
    String id;
    String isbn;
    String lang;
    String title;
    String country;
    String publisher;
    Date     regDate;
    int price;

    List<String> authors;

    public Book(){
        authors=new ArrayList<String>();
    }

    // getters and setters

    public void setAuthors( List authors ) {
       this.authors = authors;
    }

    public List getAuthors() {
       return this.authors;
    }

    public void setId( String id ) {
       this.id = id;
    }

    public String getId() {
       return this.id;
    }

    public void setIsbn( String isbn ) {
       this.isbn = isbn;
    }

    public String getIsbn() {
       return this.isbn;
    }

    public void setLang( String lang ) {
       this.lang = lang;
    }

    public String getLang() {
       return this.lang;
    }

    public void setCountry( String country ) {
       this.country = country;
    }

    public String getCountry() {
       return this.country;
    }

    public void setPublisher( String publisher ) {
       this.publisher = publisher;
    }

    public String getPublisher() {
       return this.publisher;
    }

    public void setRegDate( Date date ) {
       this.regDate = date;
    }

    public Date getRegDate() {
       return this.regDate;
    }

    public void setTitle( String title ) {
       this.title = title;
    }

    public String getTitle() {
       return this.title;
    }

    public void setPrice( int price ) {
       this.price = price;
    }

    public int getPrice() {
       return this.price;
    }

    // Create String representation of the book ....

    public String toString() {
       StringBuffer buf = new StringBuffer();

       buf.append( String.format(" Book [ id = %s ] ... \n", getId() ) );
       buf.append( String.format("   authors = [") );
       for ( int i = 0; i < authors.size(); i = i + 1 ) {
           if ( i < authors.size() - 1 ) {
              buf.append( String.format(" %s, ", authors.get(i)) );
           } else {
              buf.append( String.format(" %s] ... \n", authors.get(i)) );
           } 
       }

       buf.append( String.format("     title = %s ... \n",  this.getTitle() ) );
       buf.append( String.format(" publisher = %s ... \n",  this.getPublisher() ) );
       buf.append( String.format("   country = %s ... \n",  this.getCountry() ) );
       buf.append( String.format("  language = %s ... \n",  this.getLang() ) );
       buf.append( String.format("     price = %d ... \n",  this.getPrice() ) );
       buf.append( String.format("      isbn = %s ... \n",  this.getIsbn() ) );

       return buf.toString();
    }
}
