/*
 *  ==================================================================
 *  BuiltinMatrix.java: Builtin matrix function matrix ([ x, y ]) ....
 *
 *  Written by: Mark Austin                                  July 2013
 *  ==================================================================
 */

package whistle.builtins;

import java.lang.Math;
import whistle.*;

public class BuiltinMatrix implements FunctionMatrix {
   Matrix a;
   int noRows, noCols;
   int noArgs = 0;
   boolean DEBUG = false;

   public BuiltinMatrix () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( Matrix ... numbers ) {
      noArgs = numbers.length;
      this.a = numbers[0];

      this.noRows = (int) a.getData(0,0);
      this.noCols = (int) a.getData(0,1);

      if ( DEBUG == true ) {
         System.out.println("*** In whistle/builtins/Matrix.setValues() ....");
         System.out.println("*** noArgs = " + noArgs );
         System.out.println("*** noRows = " + noRows );
         System.out.println("*** noCols = " + noCols );
      }
   }

   public String getName() {
      return "Matrix";
   }

   public Matrix compute() {
      Matrix result = new MatrixSimple( noRows, noCols);
      return result;
   }

   // String representation of BuildMatrix() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("whistle/builtins/BuiltinMatrix(): noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }
}

