/*
 *  =================================================================
 *  BuiltinMin.java: Specification for builtin function min (x,y)....
 *
 *  Written by: Mark Austin                                June, 2013
 *  =================================================================
 */

package whistle.builtins;

import java.lang.Math;
import whistle.*;

public class BuiltinMin implements FunctionQuantity {
   Quantity a, b, c, d;
   int noArgs = 0;
   boolean DEBUG = false;

   public BuiltinMin () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( Quantity ... numbers ) {
      noArgs = numbers.length;
      this.a = numbers[0];
      this.b = numbers[1];

      if ( DEBUG == true ) {
         System.out.println("*** In whistle/builtins//Min.setValues() ....");
         System.out.println("*** noArgs = " + noArgs );
      }
   }

   public String getName() {
      return "Min";
   }

   public Quantity compute() {
      Quantity result;
      if ( DEBUG == true ) {
         System.out.println("*** Enter whistle/builtins/Min.compute() ... ");
      }

      switch ( noArgs ) {
         case 2:
              result = a.min(b);
              break;
         case 3:
              result = a.min(b).min(c);
              break;
         case 4:
              result = a.min(b).min(c).min(d);
              break;
         default:
              result = new Quantity();
              break;
      }

      if ( DEBUG == true ) {
         System.out.println("*** Result = " + result.toString() );
      }

      return result;
   }

   // String representation of Min() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("whistle/builtins/Min() function : noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }
}

