/*
 *  =================================================================
 *  BuiltinRandom.java: Builtin function sin(x)....
 *
 *  Written by: Mark Austin                                 June 2013
 *  =================================================================
 */

package whistle.builtins;

import java.lang.Math;
import whistle.*;

public class BuiltinRandom implements FunctionQuantity {
   Quantity a;
   int noArgs = 0;
   boolean DEBUG = false;

   public BuiltinRandom() {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( Quantity ... numbers ) {
      noArgs = 0;
      this.a = new Quantity(1.0);

      if ( DEBUG == true ) {
         System.out.println("*** In whistle/builtins/Abs.setValues() ....");
         System.out.println("*** noArgs = " + noArgs );
      }
   }

   public String getName() {
      return "Random";
   }

   public Quantity compute() {
      Quantity result;
      if ( DEBUG == true ) {
         System.out.println("*** Enter whistle/builtins/Quantity.compute() ... ");
         System.out.println("*** Quantity a = " + a.toString() );
      }

      switch ( noArgs ) {
         case 0:
              result = a.random();
              break;
         default:
              result = new Quantity();
              break;
      }

      if ( DEBUG == true ) {
         System.out.println("*** Result = " + result.toString() );
      }

      return result;
   }

   // String representation of Random() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("whistle/builtins/Random() function : noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }
}

