/*
 *  ==================================================================
 *  BuiltinSolve.java: Builtin matrix function solve A.x = b ....
 *
 *  Written by: Mark Austin                                  July 2013
 *  ==================================================================
 */

package whistle.builtins;

import java.lang.Math;
import whistle.*;

public class BuiltinSolve implements FunctionMatrix {
   Matrix a, b;
   int noArgs = 0;
   boolean DEBUG = false;

   public BuiltinSolve () {}

   public int getNoArgs() {
      return noArgs;
   }

   public void setValues ( Matrix ... numbers ) {
      noArgs = numbers.length;
      this.a = numbers[0];
      this.b = numbers[1];

      if ( DEBUG == true ) {
         System.out.println("*** In whistle/builtins/BuiltinSolve.setValues() ....");
         System.out.println("*** noArgs = " + noArgs );
      }
   }

   public String getName() {
      return "Solve";
   }

   public Matrix compute() {

      if ( DEBUG == true ) {
         System.out.println("*** Enter whistle/builtins/BuiltinSolve.compute() ... ");
      }

      Matrix result = a.solve(b);

      if ( DEBUG == true ) {
         System.out.println("*** Result = " + result.toString() );
      }

      return result;
   }

   // String representation of Solve() function ...

   public String toString() {
      StringBuffer buf = new StringBuffer();
      buf.append( String.format("whistle/builtins/BuiltinSolve(): noArgs = %2d\n", noArgs ) );
      return buf.toString();
   }
}

